#include "stdafx.h"
#include "tinyxml2/tinyxml2.h"
#include "LuaCfgHelper.h"
#include <iostream>
#include <boost/algorithm/string.hpp>
#include "M_ActivitySailingaChievementLevelCFG.h"
std::auto_ptr<M_ActivitySailingaChievementLevelCFG> M_ActivitySailingaChievementLevelCFG::msSingleton(nullptr);

int M_ActivitySailingaChievementLevelCFG::GetCount()
{
	return (int)mMapData.size();
}

const M_ActivitySailingaChievementLevelCFGData* M_ActivitySailingaChievementLevelCFG::GetData(int Level)
{
	auto it = mMapData.find(Level);
	if (it != mMapData.end())
	{
		return &it->second;
	}
	return NULL;
}

const std::map<int, M_ActivitySailingaChievementLevelCFGData>& M_ActivitySailingaChievementLevelCFG::GetMapData()
{
	return mMapData;
}

void M_ActivitySailingaChievementLevelCFG::Load()
{
	tinyxml2::XMLDocument xmlDoc;
	std::string content = FileUtils::getInstance()->getStringFromFile("Config/M_ActivitySailingaChievementLevelCFG.xml");
	auto result = xmlDoc.Parse(content.c_str(), content.length());
	if (result != tinyxml2::XML_SUCCESS)
	{
		CCLOGERROR("Result:%d", result);
		CCASSERT(false, "result != tinyxml2::XML_SUCCESS");
		return;
	}
	auto root = xmlDoc.RootElement();
	if (root == NULL)
	{
		CCASSERT(false, "root == NULL");
		return;
	}
	auto element = root->FirstChildElement("Data");
	while (element != NULL)
	{
		M_ActivitySailingaChievementLevelCFGData data;
		data.mLevel = element->IntAttribute("Level");
		data.mNeedAchievement = element->IntAttribute("NeedAchievement");
		{
			const char* ItemID = element->Attribute("ItemID");
			std::vector<std::string> vecItemID;
			boost::split(vecItemID, ItemID, boost::is_any_of(","));
			int temp;
			for (unsigned int i = 0; i < vecItemID.size(); i++)
			{
				if (tinyxml2::XMLUtil::ToInt(vecItemID[i].c_str(), &temp))
				{
					data.mItemID.push_back(temp);
				}
			}
		}
		{
			const char* ItemCount = element->Attribute("ItemCount");
			std::vector<std::string> vecItemCount;
			boost::split(vecItemCount, ItemCount, boost::is_any_of(","));
			int temp;
			for (unsigned int i = 0; i < vecItemCount.size(); i++)
			{
				if (tinyxml2::XMLUtil::ToInt(vecItemCount[i].c_str(), &temp))
				{
					data.mItemCount.push_back(temp);
				}
			}
		}
		if (mMapData.find(data.mLevel) != mMapData.end())std::cout <<"data refind:" << data.mLevel << std::endl;
		CCASSERT(mMapData.find(data.mLevel) == mMapData.end(), "data.mLevel is exists");
		mMapData.insert(std::make_pair(data.mLevel, data));
		element = element->NextSiblingElement();
	}
	CCLOG("M_ActivitySailingaChievementLevelCFG Loaded. Load Data:%u", mMapData.size());
}

void M_ActivitySailingaChievementLevelCFG::LoadLua()
{
	LuaEngine::getInstance()->executeScriptFile("config/M_ActivitySailingaChievementLevelCFG");
	lua_State* L = LuaEngine::getInstance()->getLuaStack()->getLuaState();
	lua_getglobal(L, "M_ActivitySailingaChievementLevelCFG");
	CCASSERT(lua_istable(L, -1) == 1, "is not table");
	lua_pushstring(L, "datas");
	lua_gettable(L, -2);
	CCASSERT(lua_istable(L, -1) == 1, "is not table");
	lua_pushnil(L);
	while(lua_next(L, 2))
	{
		CCASSERT(lua_istable(L, -1) == 1, "is not table");
		M_ActivitySailingaChievementLevelCFGData data;
		LuaCfgHelper::readInt(L, "Level", data.mLevel);
		LuaCfgHelper::readInt(L, "NeedAchievement", data.mNeedAchievement);
		LuaCfgHelper::readVectorInt(L, "ItemID", data.mItemID);
		LuaCfgHelper::readVectorInt(L, "ItemCount", data.mItemCount);
		if (mMapData.find(data.mLevel) != mMapData.end())std::cout <<"data refind:" << data.mLevel << std::endl;
		CCASSERT(mMapData.find(data.mLevel) == mMapData.end(), "data.mLevel is exists");
		mMapData.insert(std::make_pair(data.mLevel, data));
		lua_pop(L, 1);
	}
	lua_settop(L, 0);
	CCLOG("M_ActivitySailingaChievementLevelCFG Loaded. Load Data:%u", mMapData.size());
}

void M_ActivitySailingaChievementLevelCFG::Reload()
{
	mMapData.clear();
	Load();
}

M_ActivitySailingaChievementLevelCFG* M_ActivitySailingaChievementLevelCFG::GetSingleton()
{
	if (msSingleton.get() == nullptr)
	{
		msSingleton.reset(new M_ActivitySailingaChievementLevelCFG());
	}
	return msSingleton.get();
}

void M_ActivitySailingaChievementLevelCFG::Release()
{
	msSingleton.reset(nullptr);
}
